namespace Excercise01
{
    public partial class Form1 : Form
    {
        Excercise01 ex01;
        System.Windows.Forms.Timer timer;
        bool isRunning = false;

        public Form1()
        {
            InitializeComponent();
            FormClosed += StopTimer; // called when the window is closed

            canvasBox.Image = new Bitmap(canvasBox.Width, canvasBox.Height);
            ex01 = new Excercise01((Bitmap)canvasBox.Image);
        }

        private void StopTimer(object? sender, FormClosedEventArgs? e)
        {
            if (isRunning) {
                timer.Stop();
                isRunning = false;
            }
        }

        /// <summary>
        /// Sandbox button clicked
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void sandboxBT_Click(object sender, EventArgs e)
        {
            StopTimer(null, null);

            ex01.DrawingSandbox();
            canvasBox.Invalidate(); // invalidating, so the picture box is redrawn
        }

        /// <summary>
        /// Animate button clicked
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void animBT_Click(object sender, EventArgs e)
        {
            // if animation is running then stop
            if (isRunning)
            {
                timer.Stop();
                isRunning = false;
            }
            // start animation
            else
            {
                // create a new timer
                timer = new System.Windows.Forms.Timer();
                timer.Interval = 1;                             // refreshed every 1ms (how often a tick occurs)
                timer.Tick += new EventHandler(NextStepSquare); // this method is called every tick
                timer.Enabled = true;                           // start timer
                timer.Start();
                isRunning = true;
            }
        }

        private void NextStepSquare(object? sender, EventArgs e)
        {
            ex01.NextStepSquare();
            canvasBox.Invalidate();
        }

        /// <summary>
        /// Heart button is clicked
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void heartBT_Click(object sender, EventArgs e)
        {
            // stop animation
            StopTimer(null, null);

            ex01.DrawHearts();
            canvasBox.Invalidate();
        }
    }
}